<template>
  <h1>Vue 3 and Fetch Example</h1>
    <ul v-if="!loading && data && data.length">
      <li v-for="post of data"   v-bind:key="post">
        <p><strong> {{ post.id }}</strong></p>
      </li>
    </ul>

    <p v-if="loading">
      Still loading..
    </p>
  </template>

<script>
import {onMounted, ref} from "vue";
export default {
  name: 'post',
  props: {
  },
  setup() {
    const data = ref(null);
    const loading = ref(true);
   // const error = ref(null);

    function fetchData() {
      loading.value = true;
      // I prefer to use fetch
      // you can use use axios as an alternative
      return fetch('http://104.199.89.89/products', {
        method: 'get',
        headers: {
          'content-type': 'application/json'
        }
      })
          .then(res => {
            // a non-200 response code
            if (!res.ok) {
              // create error instance with HTTP status text
            //  const error = new Error(res.statusText);
             // error.json = res.json();
           //   throw error;
            }

            return res.json();
          })
          .then(json => {
            // set the response data
            data.value = json.data;
          })
          .catch(err => {
            console.log(err)
           // error.value = err;
            // In case a custom JSON error response was provided
         //   if (err.json) {
            //  return err.json.then(json => {
                // set the JSON response message
            //    error.value.message = json.message;
          //    });
          //  }
          })
          .then(() => {
            loading.value = false;
          });
    }

    onMounted(() => {
      fetchData();
    });

    return {
      data,
      loading
     // error
    };
  }

}

</script>